#ifndef Matrix_h
#define Matrix_h

//=================================================================================================


template <class T>
class Matrix {
    vec<vec<T> >    data;
public:
    Matrix(void)                                { }
    Matrix(int width, int height)               { init(width, height);      }
    Matrix(int width, int height, const T& pad) { init(width, height, pad); }

    void init(int width, int height)               { clear(); data.growTo(height); for (int i = 0; i < height; i++) data[i].growTo(width);      }
    void init(int width, int height, const T& pad) { clear(); data.growTo(height); for (int i = 0; i < height; i++) data[i].growTo(width, pad); }

    void clear(void) { data.clear(); }

    int  width (void) { return (data.size() == 0) ? 0 : data[0].size(); }
    int  height(void) { return data.size(); }

    const vec<T>& operator [] (int index) const  { return data[index]; }
    vec<T>&       operator [] (int index)        { return data[index]; }

    const T& operator [] (pair<int,int> indices) const  { return data[indices.snd][indices.fst]; }
    T&       operator [] (pair<int,int> indices)        { return data[indices.snd][indices.fst]; }
};


//=================================================================================================

#endif
